import * as React from "react";
import type { Store, Event } from "effector";
import type { Match, NavigateOptions } from "./types";
declare type RouteChildrenFunction<PathParamKeys extends string = never> = (match: Match<PathParamKeys>) => React.ReactNode;
export declare type RouteProps<PathParamKeys extends string = never> = {
    exact?: boolean;
    children?: React.ReactNode | RouteChildrenFunction<PathParamKeys>;
};
export declare type Route<PathParamKeys extends string = never> = {
    (props: RouteProps<PathParamKeys>): React.ReactElement | null;
    path: string;
    match: Store<Match<PathParamKeys> | null>;
    open: Event<Match<PathParamKeys>>;
    close: Event<null>;
    status: Store<boolean>;
    navigate: Event<void | NavigateOptions<PathParamKeys>>;
};
export declare const createRoute: <PathParamKeys extends string = never>(path: string) => Route<PathParamKeys>;
export declare type CurrentRoute = {
    path: null;
    navigate: Event<NavigateOptions<never>>;
};
export declare const CurrentRoute: CurrentRoute;
export {};
