import type { PartialPath } from "history";
export declare type PathParams<PathParamKeys extends string = never> = [PathParamKeys] extends [never] ? {} : Record<PathParamKeys, string>;
export declare type Match<PathParamKeys extends string = never> = {
    params: PathParams<PathParamKeys>;
    isExact: boolean;
};
export declare type HistoryMethod = "push" | "replace";
export declare type NavigateOptions<PathParamKeys extends string = never> = Partial<{
    params: Partial<PathParams<PathParamKeys>>;
    search: boolean | string;
    hash: boolean | string;
    method: HistoryMethod;
}>;
export declare type NavigateFxOptions = PartialPath & {
    method?: HistoryMethod;
};
